<?php

namespace WPRuby_CAA\Core\Features;


use WPRuby_CAA\Core\Dto\User;
use WPRuby_CAA\Core\Features\Plugins\Interface_Plugin;
use WPRuby_CAA\Core\Features\Plugins\Plugins_Factory;

class Plugins_Filter {

	protected static $_instance = null;

	public static function boot()
	{
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function __construct()
	{
		add_action('admin_init', [$this, 'filter']);
	}

	public function filter()
	{
		$user_id = get_current_user_id();

		if(!$user_id) return;

		$user = new User($user_id);

		$pluginsToBlock = $user->getPluginsRestrictedMenu();

		foreach ($pluginsToBlock as $plugin => $items) {
			$plugin = Plugins_Factory::make($plugin, $items);
			if (!$plugin instanceof Interface_Plugin) continue;
			if (!$plugin->is_installed()) continue;

			$plugin->filter();
		}
	}

}
